#include"function_define.h"
void ansys_blade(int III, int I_pd){
	ofstream ofile;
	ofile.open("./out_file/blade_dynamic.txt",ios::app);
	double gama = 0.5, bita = 0.25*pow((0.5 + gama), 2);
	double a0 = 1.0 / (bita*h*h), a1 = gama / (bita*h), a2 = 1.0 / (bita*h);
	double a3 = 1.0 / (bita * 2) - 1, a4 = gama / (bita)-1, a5 = h / 2.0*(gama / bita - 2);
	double a6 = h*(1 - gama), a7 = gama*h;
	MatrixXd Hz(3, Num_cal);
	if (I_pd == 0)  {
		Hz = A3_Y[III].transpose()*load_y[III];
	}
	else
	{
		Hz = A3_Y_pmn[III].transpose()*load_y_pmn[III];
	}  
	int Num = 3;
	VectorXd f_e(Num), df_e(Num), ddf_e(Num), Q(Num), Q_dt(Num);
	for (int i = 0; i < Num; i++){
		f_e(i) = 0; df_e(i) = 0; ddf_e(i) = 0;
	}
	VectorXd f_e_dt(Num), df_e_dt(Num), ddf_e_dt(Num);
	VectorXd F1(Num);//Ч
	MatrixXd K_Y_D(Num, Num);
	MatrixXd ft(Num_cal, Num), dft(Num_cal, Num), ddft(Num_cal, Num);
	for (int j = 0; j < Num; j++) Q(j) = Hz(j, 0);
	ddf_e = M_Y.inverse()*(Q - K_Y*f_e - C_Y*df_e);

	for (int j = 0; j < Num; j++) {
		ft(0, j) = f_e(j);
		dft(0, j) = df_e(j);
		ddft(0, j) = ddf_e(j);
	}
	K_Y_D = K_Y + a0*M_Y + a1*C_Y;//Чն
	for (int i = 1; i < Num_cal; i++){
		for (int j = 0; j < Num; j++) Q_dt(j) = Hz(j, i);//t+dtʱ̵ĺ
		F1 = Q_dt + M_Y*(a0*f_e + a2*df_e + a3*ddf_e) + C_Y*(a1*f_e + a4*df_e + a5*ddf_e);//Ч
		f_e_dt = K_Y_D.inverse()*F1;
		ddf_e_dt = a0*(f_e_dt - f_e) - a2*df_e - a3*ddf_e;
		df_e_dt = df_e + a6*ddf_e + a7*ddf_e_dt;
		f_e = f_e_dt;
		df_e = df_e_dt;
		ddf_e = ddf_e_dt;
		for (int j = 0; j < Num; j++) {
			ft(i, j) = f_e(j);
			dft(i, j) = df_e(j);
			ddft(i, j) = ddf_e(j);
		}
	}
	f_y[III].resize(Num_cal, Num);
	df_y[III].resize(Num_cal, Num);
	ddf_y[III].resize(Num_cal, Num);
	f_y_pmn[III].resize(Num_cal, Num);
	df_y_pmn[III].resize(Num_cal, Num);
	ddf_y_pmn[III].resize(Num_cal, Num);

	if (I_pd == 0){
		
		f_y[III] = ft;
		df_y[III] = dft;
		ddf_y[III] = ddft;
	}
	else
	{
		
		f_y_pmn[III] = ft;
		df_y_pmn[III] = dft;
		ddf_y_pmn[III] = ddft;
	}
	ofile << "The Number" << III + 1 << " blade_dynamic:" << endl << ft << endl;
	cout << "The Number"<<III+1<<" blade has been calculated separately!" << endl;
}
